Incubator2 = LibStub("AceAddon-3.0"):NewAddon("Incubator2", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0", "LibBars-1.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local media = LibStub("LibSharedMedia-3.0", true)
local Bars = LibStub:GetLibrary("LibBars-1.0", true)
local icon = LibStub("LibDBIcon-1.0", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Incubator2")
local mod = Incubator2
local version = GetAddOnMetadata("Incubator2", "Version") 

local RunningTimers = {}
local CurrentCombat = {}
local Killcount = {}
local LastOOC = 0
local anchor = "Incubator Anchor"
local BarCount = 0
local Lastexp = 0
local NeedTimers = 0
local IsActive
local TimerBars = {}
local db
local Timers = {}
local CurrentZone
local NEEDUpdate
local tostring = tostring
local floor = math.floor
local bitband = bit.band


local Incubator2ZoneList = {
	[BZ["Karazhan"]] = "Incubator2_Karazhan",
	[BZ["Black Temple"]] = "Incubator2_Black_Temple",
	[BZ["Gruul's Lair"]] = "Incubator2_SSC_TK",
	[BZ["Magtheridon's Lair"]] = "Incubator2_SSC_TK",
	[BZ["Serpentshrine Cavern"]] = "Incubator2_SSC_TK",
	[BZ["Tempest Keep"]] = "Incubator2_SSC_TK",
	[BZ["Zul'Aman"]] = "Incubator2_Sunwell_Plateau",
	[BZ["Sunwell Plateau"]] = "Incubator2_Sunwell_Plateau",
	[BZ["The Obsidian Sanctum"]] = "Incubator2_Ulduar",
	[BZ["Ulduar"]] = "Incubator2_Ulduar",
	[BZ["Icecrown Citadel"]] = "Incubator2_Icecrown_Citadel",
	--[BZ["Northrend"]] = "Northrend",
}

local Incubator2_Mobs = {
	[BZ["Northrend"]] = {
			-- debug
			["Mobs"] = {
				[26316]	= {1200,   1,  false},	-- 26316 Crysalline Ice Elemental
				[18466]	= {7200, 1, true},	-- 18465  Dreadfang Lurker debug
			},
			["Boss"] = {
				[26291] 	= {"reset", 26316},	-- 26291 Crystalline Ice Giant
			},
	},
}

local options = {
	type = "group",
	handler = mod,
	args = {
		head = {
			type = "header",
			name = L["General Options"],
			order = 5
		},
		disable = {
			type = 'execute',
			name = L["Disable"],
			func = function() mod:DeactivateMod() end,
			disabled = function() return not IsActive end,
			order = 7
		},
		locked = {
			type = 'toggle',
			name = L["Show anchor"],
			get = function()
				return mod.db.profile.baroptions.locked
			end,
			set = function(info, v)
				mod.db.profile.baroptions.locked = v
				mod:ToggleLock()
			end,
			order = 10
		},
		toggleminimap = {
			type = "toggle",
			name = L["Hide minimap icon"],
			get = function() return mod.db.profile.minimap.hide end,
			set = function(info, v) 
					mod.db.profile.minimap.hide = v
					mod:ToggleMinimapIcon(v)
			end,
			disabled = function() return not mod:IsEnabled() end,
			order = 12
		},
		barcount = {
			type = 'range',
			name = L["Bar count"],
			desc = L["Maximum number of bars to show at one time"],
			get = function()
				return mod.db.profile.barcount
			end,
			set = function(info, v)
				mod.db.profile.barcount = v
				NEEDUpdate = true
			end,
			min = 0,
			max = 25,
			step = 1,
			order = 15
		},
		maxshowtime = {
			type = 'range',
			name = L["Maximum time in minutes"],
			desc = L["Set the maximum time for a respawn bar to show"],
			get = function()
				return mod.db.profile.maxshowtime
			end,
			set = function(info, v)
				mod.db.profile.maxshowtime = v
				NEEDUpdate = true
			end,
			min = 0,
			max = 120,
			step = 1,
			order = 20
		},
		timebetween = {
			type = 'range',
			name = L["Time between bars"],
			desc = L["Only show bars that are further apart then this in minutes"],
			get = function()
				return mod.db.profile.timebetween
			end,
			set = function(info, v)
				mod.db.profile.timebetween = v
				NEEDUpdate = true
			end,
			min = 0,
			max = 30,
			step = 1,
			order = 25
		},
		showseconds = {
			type = 'toggle',
			name = L["Disable seconds"],
			desc = L["Disable showing seconds on text timer."],
			get = function()
				return mod.db.profile.precision
			end,
			set = function(info, v)
				mod.db.profile.precision = v
			end,
			order = 30
		},
		head2 = {
			type = "header",
			name = L["Media Options"],
			order = 35
		},
		texture = {
			type = "select",
			name = L["Texture"],
			dialogControl = "LSM30_Statusbar",
			get = function() 
				return mod.db.profile.baroptions.texture 
			end,
			set = function(info, v)
				mod.db.profile.baroptions.texture = v
				mod:UpdateBarsMedia()
			end,
			values = AceGUIWidgetLSMlists.statusbar,
			order = 40
		},
		font = {
			type = "select",
			name = L["Font"],
			dialogControl = "LSM30_Font",
			get = function() 
				return mod.db.profile.baroptions.font 
			end,
			set = function(info, v)
				mod.db.profile.baroptions.font = v
				mod:UpdateBarsMedia()
			end,
			values = AceGUIWidgetLSMlists.font,
			order = 45
		},
		fontsize = {
			type = "range",
			name = L["Font size"],
			get = function() return mod.db.profile.baroptions.fontsize end,
			set = function(info, v) mod.db.profile.baroptions.fontsize = v mod:UpdateBarsMedia() end,
			min = 1, 
			max = 30, 
			step = 1,
			order = 50
		},
		barwidth = {
			type = 'range',
			name = L["Bar width"],
			get = function()
				return mod.db.profile.baroptions.width
			end,
			set = function(info, v)
				mod.db.profile.baroptions.width = v
				mod.TimerBars:SetWidth(v)
			end,
			min = 24,
			max = 512,
			step = 1,
			order = 55
		},
		barheight = {
			type = 'range',
			name = L["Bar height"],
			get = function()
				return mod.db.profile.baroptions.height
			end,
			set = function(info, v)
				mod.db.profile.baroptions.height = v
				mod.TimerBars:SetHeight(v)
			end,
			min = 6,
			max = 64,
			step = 1,
			order = 60
		},
		barscale = {
			type = 'range',
			name = L["Bar scale"],
			get = function()
				return mod.db.profile.baroptions.scale
			end,
			set = function(info, v)
				mod.db.profile.baroptions.scale = v
				mod.TimerBars:SetScale(v)
			end,
			min = 0.5,
			max = 2,
			step = 0.1,
			order = 65
		},
		growup = {
			type = 'toggle',
			name = L["Grow up"],
			desc = L["Grow bars upward from the anchor"],
			get = function()
				return mod.db.profile.baroptions.growup
			end,
			set = function(info, v)
				mod.db.profile.baroptions.growup = v
				mod.TimerBars:ReverseGrowth(v)
			end,
			order = 70
		},
		backC = {
			type = "color",
			name = L["Background color"],
			hasAlpha = true,
			set = "SetColorOpt",
			get = "GetColorOpt",
			order = 71
		},
		startC = {
			type = "color",
			name = L["Bar Full Color"],
			hasAlpha = true,
			set = "SetColorOpt",
			get = "GetColorOpt",
			order = 72
		},
		lowC = {
			type = "color",
			name = L["Bar Low color"],
			hasAlpha = true,
			set = "SetColorOpt",
			get = "GetColorOpt",
			order = 73
		},
		endC = {
			type = "color",
			name = L["Bar Empty color"],
			hasAlpha = true,
			set = "SetColorOpt",
			get = "GetColorOpt",
			order = 74
		},
		test = {
			type = "execute",
			name = L["Test Bars"],
			func = function() mod:StartTestBars() end,
			order = 75
		},
		head3 = {
			type = "header",
			name = "",
			order = 80
		},
		clearall = {
			type = 'execute',
			name = L["Clear timers"],
			func = function()
				mod:ClearAll()
			end,
			order = 85
		},
		developer = {
			type = 'toggle',
			name = L["Developer"],
			desc = L["Outputs debug information to chat"],
			get = function()
				return mod.db.profile.dev
			end,
			set = function(info, v)
				mod.db.profile.dev = v
			end,
			order = 90
		},
	},
}

local defaults = {
	profile = {
		maxshowtime = 0,
		barcount = 5,
		timebetween = 0,
		dev = nil,
		precision = nil,
		minimap = {
			hide = true,
		},
		baroptions = {
			locked = true,
			growup = false,
			width = 128,
			height = 16,
			scale = 1.0,
			texture = "Blizzard",
			font = "Friz Quadrata TT",
			fontsize = 10,
			backC = { 0, 0, 0, 1},
			startC = { 0, 1, 0, 1},
			lowC = { 1, 1, 0, 1},
			endC = { 1, 0, 0, 1},
		},
	},
}

function mod:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("Incubator2DB", defaults)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Incubator2", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Incubator2", "Incubator2")
	self.db.RegisterCallback(self, "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	
	
	self:CreateAnchor()
	self:CreateLDBObject()
end

function mod:OnProfileChanged(event, database, newProfileKey)
	self.db = database
end

function mod:OnEnable()
	db = mod.db.profile
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "ZoneChange")
	self.TimerBars.RegisterCallback(self, "FadeFinished")
	self.TimerBars.RegisterCallback(self, "AnchorClicked")
	if not icon:IsRegistered("Incubator2") then icon:Register("Incubator2", self.obj, db.minimap) end
	
	self:ChangeState()
	self.Ghost = nil
end

function mod:OnDisable()
	media.UnregisterAllCallbacks(self)
	self.TimerBars.UnregisterAllCallbacks(self)	
end

function mod:ActivateMod()
	CurrentCombat = {}
	Killcount = {}
	LastOOC = 0
	BarCount = 0
	Lastexp = 0
	NeedTimers = 0
	IsActive = true
	NEEDUpdate = true
	
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL", "HostileYell")
	
	self.timer = self:ScheduleRepeatingTimer("PeriodicHandler", 1)
	
	self:RestartTimers()
	self:ChangeState()
end

function mod:DeactivateMod()
	IsActive = nil
	self:SaveTimers()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
	if self.timer then
		self:CancelTimer(self.timer, true) 
		self.timer = nil
	end
	self:ClearAll()
	self:ChangeState()
end

function mod:debug(message)
	if db.dev then
		self:Print(message)
	end
end

function mod:ToggleMinimapIcon(HIDE)
	if HIDE then icon:Hide("Incubator2")
	else icon:Show("Incubator2") end
end

function mod:SetColorOpt(info, r, g, b, a)
	local db = mod.db.profile.baroptions
	local opt = info[#info]
	db[opt][1] = r
	db[opt][2] = g
	db[opt][3] = b
	db[opt][4] = a
	self:UpdateBarsMedia()
end

function mod:GetColorOpt(info)
	local db = mod.db.profile.baroptions
	local opt = info[#info]
	return unpack(db[opt])
end

function mod:AnchorClicked(...)
	local button = select(3,...)
	if button == "RightButton" then
		mod.db.profile.baroptions.locked = not mod.db.profile.baroptions.locked
		self:ToggleLock()
		return
	else
		self:StartTestBars()
	end
end

function mod:FadeFinished(event, bar, name)
	self.TimerBars:ReleaseBar(bar)
	TimerBars[name] = nil
	NEEDUpdate = true
end

function mod:StartTestBars()
	for i = 1, db.barcount do
		self:CreateBar("Bar"..i, 120 - i * 20, 120)
	end
end

function mod:CheckZone()
	local currentzone = GetInstanceInfo()
	self:debug(currentzone)
	if Incubator2ZoneList[currentzone] then
		local worked = self:LoadCurrentZoneData(currentzone)
		if worked then CurrentZone = currentzone 
		else CurrentZone = nil end
		return true
	end
	return false
end

function mod:ZoneChange()
	self:debug("Zonechange")
	if UnitIsGhost("player") then self.Ghost = true return end
	if self.Ghost then self.Ghost = nil return end
	if self:CheckZone() then self:ActivateMod()
	else self:DeactivateMod() 
	end
	self:ChangeState()
end

function mod:LoadCurrentZoneData(zone)
	if zone then
		local loadzone = Incubator2ZoneList[zone]
		self:debug("Preparing to load module: "..loadzone)
		local _, _, _, enabled = GetAddOnInfo(loadzone)
		if not Incubator2_Mobs[zone] then
			if enabled then
				local success, fail = LoadAddOn(loadzone)
				if not success then
					self:debug("Load failed on module "..loadzone.." because "..fail) 
					return false
				else
					self:debug("Loaded module "..loadzone) 
					Incubator2_Mobs[zone] = Incubator2_Data
					Incubator2_Data = nil
					return true
				end
			else
				self:debug("Please enable module: "..loadzone)
				return false
			end
		else
			self:debug("Module "..loadzone.." is already loaded")
			return true
		end
	else
		self:debug("Invalid zone: "..zone)
	end
	return false
end

function mod:ChangeState()
	if not mod.obj then return end
	if IsActive then mod.obj.icon = "Interface\\AddOns\\Incubator2\\Icons\\SyncON"
	else mod.obj.icon = "Interface\\AddOns\\Incubator2\\Icons\\SyncOFF"
	end
	self:UpdateBrokerText()
end

function mod:CreateAnchor()
	db = mod.db.profile
	self.TimerBars = self:NewBarGroup("Incubator2", Bars.LEFT_TO_RIGHT, db.baroptions.width, db.baroptions.height, "Incubator2_TimerBars")
	self.TimerBars:HideIcon()
	self.TimerBars:SetUserPlaced(true)
	self:UpdateBarsMedia()
end

function mod:UpdateBarsMedia()
	self.TimerBars:SetFont(media:Fetch("font", db.baroptions.font), db.baroptions.fontsize)
	self.TimerBars:SetWidth(db.baroptions.width)
	self.TimerBars:SetHeight(db.baroptions.height)
	self.TimerBars:SetTexture(media:Fetch("statusbar", db.baroptions.texture))
	self.TimerBars:SetColorAt(1, unpack(db.baroptions.startC))
	self.TimerBars:SetColorAt(0.25, unpack(db.baroptions.lowC))
	self.TimerBars:SetColorAt(0, unpack(db.baroptions.endC))
	self.TimerBars:SetScale(db.baroptions.scale)
	self.TimerBars:ReverseGrowth(db.baroptions.growup)
	self:ToggleLock()
end

function mod:ToggleLock()
	if not db.baroptions.locked then
		self.TimerBars:HideAnchor()
	else
		self.TimerBars:ShowAnchor()
	end
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Incubator2", {
		type = "data source",
		icon = "Interface\\AddOns\\Incubator2\\Icons\\SyncOFF",
		label = "Incubator2",
		text = "",
		OnClick = function(frame, button)
				if button == "RightButton" then
					if not C.OpenFrames["Incubator2"] then C:Open("Incubator2") 
					else C:Close("Incubator2") end
				else 
					if IsActive then
						if IsControlKeyDown() then mod:DeactivateMod()
						elseif Timers[1] then
							local currenttime = GetTime()
							if IsShiftKeyDown() then
								mod:ClearTimer(Timers[1].name)
							elseif IsAltKeyDown() then
								for _,timer in ipairs(Timers) do
									SendChatMessage(timer.name .. ": " .. mod:FormatTime(RunningTimers[timer.name][1] - currenttime), "RAID")
								end
							else
								SendChatMessage(Timers[1].name .. ": " .. mod:FormatTime(RunningTimers[Timers[1].name][1] - currenttime), "RAID")
							end
						end
					else 
						mod:Enable()
						mod:ActivateMod()
					end
				end
			end,
		OnEnter = function(frame)
				local tooltip = QTC:Acquire("Incubator2_Tooltip", 2, "LEFT", "RIGHT")
				tooltip:Clear()
				tooltip:SmartAnchorTo(frame)
				tooltip:SetScript("OnLeave", mod.HideTooltip)
				tooltip:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
				mod.tooltip = tooltip
				mod:DisplayTooltip()
			end,
		OnLeave = function()
				mod:HideTooltip()
			end,
	})

end

function mod:HideTooltip(force)
	if self.tooltip then
		if MouseIsOver(self.tooltip) and not force then return end
		self.tooltip:SetScript("OnLeave", nil)
		self.tooltip:SetScript("OnUpdate", nil)
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	local text = ""
	if IsActive then
    		local currenttime = GetTime()
		if Timers[1] then
			local time = RunningTimers[Timers[1].name][1] - currenttime
			if time < 600 then text = "|c00bb0000"
			elseif time < 1200 then text = "|c00ffff33"
			else text = "|c001eff00" end
			text = text .. SecondsToTime(time, db.precision) .. "|r"
		end
	end
	mod.obj.text = text
end

function mod:DisplayTooltip()
	local tooltip = mod.tooltip
	self:UpdateBrokerText()
	if not tooltip then return end
	
	local y, x = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|c001eff00" .. "Incubator2 " .. "|r|c000070dd" .. version .. "|r", nil, "CENTER", 2)
	tooltip:AddLine("")	
	if IsActive then
		local currenttime = GetTime()
		for key, data in ipairs(Timers) do
			local color = "|c0000ff00"
			local time = RunningTimers[data.name][1] - currenttime
			if time < 600 then color = "|c00bb0000"
			elseif time < 1200 then color = "|c00ffff33"
			end
			tooltip:AddSeparator()
			local y, x = tooltip:AddLine(data.name, color .. SecondsToTime(time, db.precision) .. "|r")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, data.name) 
		end
		tooltip:AddSeparator(1,1,1,1,1)
		tooltip:AddLine("")	
		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["|c000070ddClick:|r Output to raid.\n|c000070ddSHIFT-Click:|r Delete timer."], nil, "CENTER", 2)      
      	else
      		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["On STANDBY. \n|c000070ddClick|r to enable."], nil, "CENTER", 2) 
      	end
	 
        tooltip:UpdateScrolling()
        tooltip:Show()
end

function mod:CreateBar(name, time, maxtime)
	local bar = self.TimerBars:NewTimerBar(name, name, time, maxtime)
	bar:SetBackgroundColor(unpack(db.baroptions.backC))
	TimerBars[name] = bar
end

function mod:SortTimers()
	Timers = {}
	local count = 1
	for name, value in pairs(RunningTimers) do
		Timers[count] = {name = name, time = value[1]}
		count = count + 1
	end
	table.sort(Timers, function(a,b) return a.time<b.time end)
	NEEDUpdate = true
end

function mod:RestartTimers()
	-- reset existing timers, etc
	self:debug("Restart Timers...")
	RunningTimers = {}
	local timestamp = db.timestamp
	local diff = self:TimeDiff(timestamp, date("%m/%d/%y %H:%M:%S"))
	if diff > 8000 then self:ClearAll() return end
	local currtime = GetTime()
	if db.timers then
		for key, value in pairs(db.timers) do
			RunningTimers[key] = {}
			RunningTimers[key][1] = value[1] + currtime - diff 
			RunningTimers[key][2] = true
			RunningTimers[key][3] = true
			RunningTimers[key][4] = value[4]
			RunningTimers[key][5] = value[5]
			if RunningTimers[key][1] < 0 then self:ClearTimer(key) end
		end
	end
	mod:SortTimers()
	mod:UpdateBrokerText()
end

function mod:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	local dstValid = (bitband(dstFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) ~= 0)  
	if eventtype == "UNIT_DIED" and dstValid then
		local mobID = tonumber(string.sub(dstGUID, 9, 12), 16)
		self:HostileDeath(dstName, mobID)
	end
end

function mod:HostileDeath(mobName, UID)
	-- increment a death counter and start timers if needed
	--self:debug(mobName.."="..UID)
	--db.unitGUIDs[mobName] = UID
	if not CurrentZone then self:debug("Zone is nil!") return end
	local LookupTable = Incubator2_Mobs[CurrentZone].Mobs
	local BossLookupTable = Incubator2_Mobs[CurrentZone].Boss
	
	if LookupTable[UID] then	-- The thing that died is on our list of stuff that can be tracked.
		if  LookupTable[UID][2] == -1 and  LookupTable[UID][3] == false then -- The thing that died is tracked as a solo mob
			self:StartTimer(mobName,  LookupTable[UID][1], UID)
		else
			NeedTimers = 1
			CurrentCombat[UID] = mobName
			if Killcount[UID] == nil then
				Killcount[UID] = 1
			else
				Killcount[UID] = Killcount[UID] + 1
			end
			self:debug(mobName, "found on list to be tracked.", Killcount[UID], "this combat.")
		end
	end
	if BossLookupTable[UID] then self:BossDeath(UID) end	-- A boss died, so kill all the timers associated with that boss.
end

function mod:HostileYell()
	if arg1 == L["Stay your arms! I yield!"] then	--Thorim
  		self:BossDeath(33413)
 	elseif arg1 == L["It would appear that I've made a slight miscalculation. I allowed my mind to be corrupted by the fiend in the prison, overriding my primary directive. All systems seem to be functional now. Clear."] then
  		self:BossDeath(33244)	--Mimiron
  	elseif arg1 == L["His hold on me dissipates. I can see clearly once more. Thank you, heroes."] then	--Freya
  		self:BossDeath(33410)
 	elseif arg1 == L["I... I am released from his grasp... at last."] then	--Hodir
  		self:BossDeath(33213)
  	end
end

function mod:PLAYER_REGEN_DISABLED()
	LastOOC = 0
	self:StopOOCHandler()
end

function mod:StopOOCHandler()
	if self.OOCtimer then
		self:CancelTimer(self.OOCtimer, true) 
		self.OOCtimer = nil
	end
end

function mod:StartOOCHandler()
	if not self.OOCtimer then
		self.OOCtimer = self:ScheduleRepeatingTimer("OOCHandler", 1)
	end
end

function mod:BossDeath(UID, called)
	if UID == 17533 and not called then return end	-- R&J
	if UID == 25165 or UID == 25166 then -- 25165 Lady Sacrolash and 25166 Grand Warlock Alythess
		if Killcount[25165] ~= 1 or Killcount[25166] ~= 1 then return end
	end
	
	if not CurrentZone then self:debug("Zone is nil!") return end
	local LookupTable = Incubator2_Mobs[CurrentZone].Mobs
	local BossLookupTable = Incubator2_Mobs[CurrentZone].Boss
	
	for tindex, mobID in pairs(BossLookupTable[UID]) do
		if mobID ~= "remove" and mobID ~= "reset" then
			for timername, timerlist in pairs(RunningTimers) do
				if timerlist[4] == mobID then
					if timerlist[3] == false then	--bar was started on this one
						TimerBars[timername]:Fade(0.5)
						BarCount = BarCount - 1
					end
					RunningTimers[timername] = nil
				end
			end
			if BossLookupTable[UID][1] == "remove" then
				LookupTable[mobID] = nil -- Prevent new bars from being started on this mob
			end
		end
	end

	if UID == 15691 then    --Curator
		LookupTable[16485] = {7200, 2, false,}       --Arcane Watchman
	end
	
	if UID == 16524 then    --Shade
		LookupTable[16525] = {7200, -1, true}        --Spell Shade
	end
	if db.dev then
		self:Print("Boss died..."..UID)
	end
	self:SortTimers()
	self:UpdateBrokerText()
	self:SaveTimers()
end

function mod:PLAYER_REGEN_ENABLED()
	self:debug("Starting OOC checking")
	LastOOC = GetTime()
	if NeedTimers == 1 then
		self:StartOOCHandler()
	end
end

function mod:StartTimer(name, duration, UID)
	local counter = 1
	local expiration = duration + LastOOC
	local title = name .. tostring(counter)

	while RunningTimers[title] ~= nil do
		counter = counter + 1
		title = name .. tostring(counter)
	end
	
	
	RunningTimers[title] = { expiration, true, true, UID, duration}
	self:debug("Starting timer named", title, (SecondsToTime(duration - GetTime())))
	self:SortTimers()
	if db.barcount > 0  and #Timers > 1 then
		local match = nil
		if db.barcount == 1 then
			if Timers[1].bar and not Timers[2].bar then match = true end
		else
			for num = 1, #Timers - 1 do
				if num < db.barcount and (not Timers[num+1].bar and Timers[num].bar) then
					match = true
					break
				end
			end
		end
		if match then
			for index, data in ipairs(Timers) do
				local bar = RunningTimers[data.name][3]
				if not bar then 
					TimerBars[data.name]:Fade(0.5)
					RunningTimers[data.name][3] = true
				end
			end
			BarCount = 0
			Lastexp = 0
		end
	end
	self:SaveTimers()
end

function mod:TimerHandler()
	-- handles all the timers that need to be started and clearing out the current combat list
	self:debug("Processing Timers")
	if not CurrentZone then self:debug("Zone is nil!") return end
	local LookupTable = Incubator2_Mobs[CurrentZone].Mobs
	
	local StartedNonHomogeneous = false -- Flag to indicate that we already started a timer on a pack
	for key, value in pairs(CurrentCombat) do
		if Killcount[key] ~= nil and LookupTable[key] ~= nil then
			if value  then
				if Killcount[key] >= LookupTable[key][2] then
					if LookupTable[key][3] == true and not StartedNonHomogeneous then
						StartedNonHomogeneous = true
						-- Start a timer on this particular mob. We only want to start the timer on this one instead of 2+ mobs with the same timer.
						self:StartTimer(value, LookupTable[key][1], key)
					end
					if LookupTable[key][3] == false then
					-- Start a timer on that mob, enough of them died. These are solo so we don't care about other deaths.
						self:StartTimer(value, LookupTable[key][1], key)
					end
					Killcount[key] = nil
				else
					if (key == 17533 or key == 17534) and  Killcount[17533]  and  Killcount[17534] then	-- R&J
						if Killcount[17533]  >  1 and  Killcount[17534]  >  1 and Killcount[17533]  ==  Killcount[17534] then self:BossDeath(17533, true) end
					end
					self:debug("Discarding info on", key, "(Got", Killcount[key], "needed", LookupTable[key][2], ")")
					Killcount[key] = nil
				end
			end
		end
		CurrentCombat[key] = nil
	end
	NeedTimers = 0
end

function mod:PeriodicHandler()
	self:UpdateBrokerText()
	if not NEEDUpdate then return end
	NEEDUpdate = nil
	local threshold = db.barcount
	local ttime = GetTime()
	if BarCount < 0 then BarCount = 0 end
	local showthreshold = db.maxshowtime
	if showthreshold == 0 then showthreshold = 999 end
	for _, timerdata in ipairs(Timers) do
		local name = timerdata.name
		local realdata = RunningTimers[name]
		local expiry = realdata[1]
		local warn = realdata[2]
		local bar = realdata[3]
		local remaining = floor(expiry - ttime)
		local duration = realdata[5]
		--[[ RunningTimers format is 
			RunningTimers[Timername]
				[1] = expiration time
				[2] = Warning needs to be given
				[3] = Bar needs to be started
				[4] = Unit ID
				[5] = duration
		]]-- 
		if ttime + 600 > expiry and warn and db.dev then
			self:Print(name, "respawns in", remaining)
			RunningTimers[name][2] = false
		end
		if ttime + (60 * showthreshold) > expiry and bar and BarCount < threshold and (expiry - Lastexp) > (db.timebetween * 60) then
			self:CreateBar(name, remaining, duration) 
			RunningTimers[name][3] = false
			self:debug(name, "is being flagged as starting a timer")
			BarCount = BarCount + 1
			if Lastexp < expiry or Lastexp == 0 then Lastexp = expiry end
		end
		
		if ttime > expiry then self:ClearTimer(name) end
	end
	if #Timers > threshold then
		for i = threshold + 1, #Timers do
			if not RunningTimers[Timers[i].name][3] then 
				RunningTimers[Timers[i].name][3] = true
				if RunningTimers[Timers[i].name][1] == Lastexp then Lastexp = 0 end 
				TimerBars[Timers[i].name]:Fade(.5)
				BarCount = BarCount - 1
			end
		end
	end
end

function mod:HandleTTClick(name, button)
	if not name then return end
        mod:debug("Caught mouseclick on", name)
        
        if IsShiftKeyDown() then
		mod:debug("Clearing timer", name)
		mod:ClearTimer(name)
	else
		local time = mod:FormatTime(floor(RunningTimers[name][1] - GetTime()))
		if UnitInRaid("player") == nil then
			SendChatMessage(name .. ": " .. time, "SAY")
		else
			SendChatMessage(name .. ": " .. time, "RAID")
		end
	end
end

function mod:FormatTime(time)
	local STT =  string.gsub(SecondsToTime(time, db.precision), "|4", "")
	STT = string.gsub(STT, ":Hr", "")
	STT = string.gsub(STT, ":Min", "")
	STT = string.gsub(STT, ":Sec", "")
	STT = string.gsub(STT, ";", "")
	return STT
end

function mod:ClearTimer(name)
	self:debug("Clear timer "..name)
	if RunningTimers[name][1] == Lastexp then
		Lastexp = 0
	end
	RunningTimers[name] = nil
	if TimerBars[name] then 
		TimerBars[name]:Fade(.5)
		BarCount = BarCount - 1
	end
	self:SortTimers()
	self:UpdateBrokerText()
	self:SaveTimers()
end

function mod:InCombat()
	if UnitAffectingCombat("player") == nil then
		if UnitInRaid("player") == nil then
			local n = GetNumPartyMembers()
			if n == 0 then
				return false
			else
				for i = 1, n do
					if UnitAffectingCombat("party" .. i) == 1 then
						return true
					end
				end
				return false
			end
		else
			local n = GetNumRaidMembers()
			for i = 1, n do
				if UnitAffectingCombat("raid" .. i) == 1 then
					return true
				end
			end
			return false
		end
	else
		return true
	end
end

function mod:IsRaidAlive()
	local count = 0
	if UnitInRaid("player") == nil then
		local n = GetNumPartyMembers()
		if UnitIsDeadOrGhost("player") == true then
			count = count + 1
		end
		if n ~= 0 then
			for i = 1, n do
				if UnitIsDeadOrGhost("party" .. i) == true or UnitIsConnected("party" .. i) ~= 1 then
					count = count + 1
				end
			end
		end
		if count == n + 1 then
			return false -- everyone is dead!
		else
			return true
		end
	else
		local n = GetNumRaidMembers()
		for i = 1, n do
			if UnitIsDeadOrGhost("raid" .. i) == true or UnitIsConnected("raid" .. i) ~= 1 then
				count = count + 1
			end
		end
		if count == n then
			return false
		else
			return true
		end
	end
end

function mod:OOCHandler()
	if not self:IsRaidAlive() then -- Boo wiping! Try harder!
		self:debug("Wipe detected, stopping processing")
		self:StopOOCHandler()
		self:EmptyCombatList()
	elseif not self:InCombat() then
		self:debug("The party/raid appears to be OOC")
		LastOOC = GetTime()
		self:StopOOCHandler()
		self:TimerHandler()
	end
end

function mod:EmptyCombatList()
	self:debug("Emptying Combat List")
	for key, value in pairs(CurrentCombat) do
		CurrentCombat[key] = nil
	end
	for key, value in pairs(Killcount) do
		Killcount[key] = nil
	end
	NeedTimers = 0
end

function mod:ClearAll()
	self:debug("Clear All timers")
	
	for timername, timerlist in pairs(RunningTimers) do
		if timerlist[3] == false  then -- candybar was started on this one
			if TimerBars[timername] then
				TimerBars[timername]:Fade(0.5)
			end
		end
		RunningTimers[timername] = nil
	end
	BarCount = 0
	Lastexp = 0
	self:SortTimers()
	self:UpdateBrokerText()
end

function mod:TimeDiff(time1, time2) -- time1 is saved time, time2 is current time
	local hours1, hours2, min1, min2, sec1, sec2, day1, day2, total1, total2, timediff
   
	if time1 and time2 then
		local _, _,  day1, hours1, min1, sec1 = string.find(time1, "%d+/(%d+)/%d+ (%d+):(%d+):(%d+)")
		local _, _,  day2, hours2, min2, sec2 = string.find(time2, "%d+/(%d+)/%d+ (%d+):(%d+):(%d+)")
		--DEFAULT_CHAT_FRAME:AddMessage("d"..day1.."h"..hours1.."m"..min1.."s"..sec1)
		total1 = ((( hours1 * 60 ) + min1) *60) + sec1
		total2 = ((( hours2 * 60 ) + min2) *60) + sec2
		if day2 ~= day1 then
			if day2 > day1 then total2 = total2 + 86400 
			else total1 = total1 + 86400 end
		end
    		timediff = total2 - total1
    		self:debug("Time difference = "..(timediff or "nil"))
		return timediff
    	end
    	return 0
end   

function mod:SaveTimers()
	db.timers = {}
	local currtime = GetTime()
	for timername, timerlist in pairs(RunningTimers) do
		db.timers[timername] = {}
		db.timers[timername][1] = timerlist[1]  - currtime
		db.timers[timername][4] = timerlist[4]
		db.timers[timername][5] = timerlist[5]
	end
	db.timestamp = date("%m/%d/%y %H:%M:%S")
end
